#include <stdio.h>

int main() {
    int n, sum, len;
    while(1){
        scanf("%d",&n);
        if(n==-1) break;

        sum=1;
        len=0;
        int fac[36] = {1,};
        for(int i=2; i<=n/2; i++){
            if(n%i==0) {
                sum+=i;
                fac[++len]=i;
            }
        }

        if(sum==n){
            printf("%d = 1",n);
            for(int i=1; i<=len; i++) {
                printf(" + %d",fac[i]);
            }
        }
        else {
            printf("%d is NOT perfect.",n);
        }
        printf("\n");
    }

    return 0;
}